;
;                          
;                                
;                                      
;                              
;                        v1.1
;            The Custom Menu Customizer by Sam Davies
;                    sdavies@mail.trilogy.net
;
;To reduce the size of the appended code, simply change the value for
;NUM_SLOTS (must be from 1 to 14), and recompile.
;
NUM_SLOTS = 14
;


#if (NUM_SLOTS > 14)
!!! Error: NUM_SLOTS must be <=14
#endif
#if (NUM_SLOTS < 1)
!!! Error: NUM_SLOTS must be >=1
#endif

#include "usgard.h"
#include "explrlib.h"
#include "ugapplib.h"
#include "winlib.h"

.org 0
Title:
.db "CustCust v1.0 by SD",0,0
;.db EXPLLIB,UGAPPLIB,WINLIB,0
Ask:

        ld      HL, &ID_STR_BEGIN
        ld      BC, ID_STR_END-ID_STR_BEGIN
        LIB_CALL_(UGAPPLIB,CHECK_APPEND)
        jp      z, &Install
        ld      (&IDSB_POS), HL
        call    &InitWin

        ld      BC, 4<<8 + 11
        ld      HL, 8<<8 + 40
        ld      DE, &Title
        ld      IX, &Contents
        ld      A, 00000011b
        LIB_CALL_(WINLIB,WIN_PSHOW)
        ld      B, NUM_SLOTS
        ld      HL, &HANDLE_SLOTS
        LIB_CALL_(WINLIB,WIN_CHC_EX)
        ret     c
        xor     A
        cp      D
        jp      z, &Uninstall
        dec     D
        push    DE

        ld      BC, &Choose
        ld      HL, $0000
        ld      DE, $FAFD
        LIB_CALL_(EXPLLIB,EXPLORE)
        pop     DE
        ret     nc
        push    DE
        ld      L, D
        ld      H, 9
        call    MUL_HL
        ex      DE, HL
        ld      HL, (&IDSB_POS)
        ld      BC, StringNames-ID_STR_BEGIN
        add     HL, BC
        add     HL, DE
        ex      DE, HL
        ld      HL, OP2
        ld      BC, 9
        ldir
        pop     AF
        ld      HL, &Addresses
        add     A, A
        ld      C, A
        ld      B, 0
        add     HL, BC
        call    LD_HL_MHL
        ld      DE, (&IDSB_POS)
        add     HL, DE
        push    HL
        ex      DE, HL

        ld      HL, $8BB5
        add     HL, BC
        ld      (HL), E
        inc     HL
        ld      (HL), D

        ld      BC, 5<<8 + 25
        ld      HL, 6<<8 + 16
        ld      DE, &EnterName
        ld      A, 00000001b
        LIB_CALL_(WINLIB,WIN_PSHOW)
        ld      HL, $0704
        ld      (CURSOR_ROW), HL
        pop     IX
        ld      BC, 6
        add     IX, BC
        push    IX
        ld      A, 00010000b
        call    OTH_INPST
        pop     IX
        ld      A, (IX)
        and     A
        ret     nz
        ld      (IX), $20
        ld      (IX+1), 0
        ret

Install:
        ld      HL, &APPEND_CODE
        ld      BC, APPEND_CODE_END-APPEND_CODE
        LIB_CALL_(UGAPPLIB,APPEND)
        ld      D, H
        ld      E, L
        ld      BC, StringNames-APPEND_CODE
        add     HL, BC
        ex      DE, HL
        ld      BC, (ID_STR_BEGIN-2)-APPEND_CODE
        add     HL, BC
        ld      (HL), E
        inc     HL
        ld      (HL), D

        ld      BC, 6<<8 + 24
        ld      HL, 4<<8 + 16
        ld      DE, &Success
        ld      IX, &Installed
        ld      A, 00000011b
        LIB_CALL_(WINLIB,WIN_PSHOW)
        call    OTH_PAUSE
        jp      &Ask

Uninstall:
        ld      HL, &ID_STR_BEGIN
        ld      BC, ID_STR_END-ID_STR_BEGIN
        LIB_CALL_(UGAPPLIB,CHECK_APPEND)
        push    HL
        ld      HL, ($8BF7)
        ld      DE, $8BF9
        add     HL, DE
        ex      DE, HL
        pop     HL
        push    HL
        ld      BC, APPEND_CODE_END-ID_STR_BEGIN
        add     HL, BC
        call    CP_HL_DE
        pop     HL
        jr      nz, TSRs
        ld      BC, APPEND_CODE_END-APPEND_CODE
        LIB_CALL_(UGAPPLIB,UNAPPEND)
        ld      HL, $8BB5
        ld      DE, $8BB6
        ld      (HL), 0
        ld      BC, NUM_SLOTS*2-1
        ldir
        ld      BC, 6<<8 + 24
        ld      HL, 4<<8 + 16
        ld      DE, &Success
        ld      IX, &Removed
        ld      A, 00000011b
        LIB_CALL_(WINLIB,WIN_PSHOW)
        call    OTH_PAUSE
        ret

TSRs:
        ld      BC, 4<<8 + 24
        ld      HL, 7<<8 + 24
        ld      DE, &Note
        ld      IX, &RemoveApp
        ld      A, 00000011b
        LIB_CALL_(WINLIB,WIN_PSHOW)
        call    OTH_PAUSE
        ret        

HANDLE_SLOTS:
        push    DE
        call    GET_KEY
        cp      K_DEL
        pop     DE
        ret     nz
        xor     A
        cp      D
        ret     z
        dec     D
        sla     D
        ld      E, D
        ld      D, 0
        ld      HL, $8BB5
        add     HL, DE
        ld      (HL), D
        inc     HL
        ld      (HL), D
        push    BC
        call    &InitWin
        LIB_CALL_(WINLIB,WIN_SHOW)
        pop     BC
        LIB_CALL_(WINLIB,WIN_INVERT)
        xor     A
        ret


InitWin:
        ld      HL, $8BB5
        ld      IX, &Menu_Start+4
        ld      B, NUM_SLOTS
NextLine:
        push    bc
        ld      E, (HL)
        inc     HL
        ld      D, (HL)
        inc     HL
        ld      A, E
        or      D
        jr      z, setEMPTY
        inc     DE
        inc     DE
        inc     DE
        inc     DE
        inc     DE
        inc     DE
        jr      notEMPTY
setEMPTY:
        ld      DE, &EMPTY
notEMPTY:
        ld      B, 6
CopyLoop:
        ld      A, (DE)
        and     A
        jr      z, ZeroFound
        ld      (IX), A
        inc     IX
        inc     DE
        djnz    CopyLoop
Continue:
        ld      BC, 4
        add     IX, BC
        pop     BC
        djnz    NextLine
        ret

ZeroFound:
        ld      A, $20
CopyAgain:
        ld      (IX), A
        inc     IX
        djnz    CopyAgain
        jr      Continue
IDSB_POS:
.dw 0

EMPTY:
.db "EMPTY",0
Contents:
.db "Uninstall"
Menu_Start:
#if (NUM_SLOTS>=1)
.db LF,"2  NOT WR"
#else
.db 0
#endif
#if (NUM_SLOTS>=2)
.db LF,"3  NOT WR"
#else
.db 0
#endif
#if (NUM_SLOTS>=3)
.db LF,"4  NOT WR"
#else
.db 0
#endif
#if (NUM_SLOTS>=4)
.db LF,"5  NOT WR"
#else
.db 0
#endif
#if (NUM_SLOTS>=5)
.db LF,"6  NOT WR"
#else
.db 0
#endif
#if (NUM_SLOTS>=6)
.db LF,"7  NOT WR"
#else
.db 0
#endif
#if (NUM_SLOTS>=7)
.db LF,"8  NOT WR"
#else
.db 0
#endif
#if (NUM_SLOTS>=8)
.db LF,"9  NOT WR"
#else
.db 0
#endif
#if (NUM_SLOTS>=9)
.db LF,"10 NOT WR"
#else
.db 0
#endif
#if (NUM_SLOTS>=10)
.db LF,"11 NOT WR"
#else
.db 0
#endif
#if (NUM_SLOTS>=11)
.db LF,"12 NOT WR"
#else
.db 0
#endif
#if (NUM_SLOTS>=12)
.db LF,"13 NOT WR"
#else
.db 0
#endif
#if (NUM_SLOTS>=13)
.db LF,"14 NOT WR"
#else
.db 0
#endif
#if (NUM_SLOTS=14)
.db LF,"15 NOT WR",0
#endif

Addresses:
#if (NUM_SLOTS>=1)
.dw SLOT_2-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=2)
.dw SLOT_3-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=3)
.dw SLOT_4-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=4)
.dw SLOT_5-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=5)
.dw SLOT_6-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=6)
.dw SLOT_7-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=7)
.dw SLOT_8-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=8)
.dw SLOT_9-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=9)
.dw SLOT_10-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=10)
.dw SLOT_11-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=11)
.dw SLOT_12-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=12)
.dw SLOT_13-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=13)
.dw SLOT_14-ID_STR_BEGIN
#endif
#if (NUM_SLOTS>=14)
.dw SLOT_15-ID_STR_BEGIN
#endif

Choose:
.db "Choose A File",0
EnterName:
.db "Name",0
NONAME:
.db "NoName",0
Success:
.db "Success!",0
Note:
.db "Failure",0
Removed:
.db "Removed",0
RemoveApp:
.db "Remove other     "
.db "appended code.",0
Installed:
.db "Installed",0

APPEND_CODE:

#if (NUM_SLOTS>=14)
SLOT_15:
        .db $41,$00,$07
        xor     A
        jr      C_15
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=13)
SLOT_14:
        .db $41,$00,$07
        xor     A
        jr      C_14
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=12)
SLOT_13:
        .db $41,$00,$07
        xor     A
        jr      C_13
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=11)
SLOT_12:
        .db $41,$00,$07
        xor     A
        jr      C_12
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=10)
SLOT_11:
        .db $41,$00,$07
        xor     A
        jr      C_11
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=9)
SLOT_10:
        .db $41,$00,$07
        xor     A
        jr      C_10
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=8)
SLOT_9:
        .db $41,$00,$07
        xor     A
        jr      C_9
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=7)
SLOT_8:
        .db $41,$00,$07
        xor     A
        jr      C_8
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=6)
SLOT_7:
        .db $41,$00,$07
        xor     A
        jr      C_7
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=5)
SLOT_6:
        .db $41,$00,$07
        xor     A
        jr      C_6
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=14)
C_15:   inc     A
#endif
#if (NUM_SLOTS>=13)
C_14:   inc     A
#endif
#if (NUM_SLOTS>=12)
C_13:   inc     A
#endif
#if (NUM_SLOTS>=11)
C_12:   inc     A
#endif
#if (NUM_SLOTS>=10)
C_11:   inc     A
#endif
#if (NUM_SLOTS>=9)
C_10:   inc     A
#endif
#if (NUM_SLOTS>=8)
C_9:    inc     A
#endif
#if (NUM_SLOTS>=7)
C_8:    inc     A
#endif
#if (NUM_SLOTS>=6)
C_7:    inc     A
#endif
#if (NUM_SLOTS>=5)
C_6:    inc     A
#endif
#if (NUM_SLOTS>=4)
C_5:    inc     A
#endif
#if (NUM_SLOTS>=3)
C_4:    inc     A
#endif
#if (NUM_SLOTS>=2)
C_3:    inc     A
#endif
C_2:

Exec:
        call    BUSY_OFF

        ld      DE, StringNames
ID_STR_BEGIN:
        ld      L, A
        ld      H, 9
        push    DE
        call    MUL_HL
        pop     DE
        add     HL, DE
        call    VAR_EXEC
        call    CLEARTEXT
        jp      462h
ID_STR_END:

#if (NUM_SLOTS>=4)
SLOT_5:
        .db $41,$00,$07
        xor     A
        jr      C_5
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=3)
SLOT_4:
        .db $41,$00,$07
        xor     A
        jr      C_4
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=2)
SLOT_3:
        .db $41,$00,$07
        xor     A
        jr      C_3
        .db 0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=1)
SLOT_2:
        .db $41,$00,$07
        xor     A
        jr      C_2
        .db 0,0,0,0,0,0,0
#endif

StringNames:

#if (NUM_SLOTS>=14)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=13)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=12)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=11)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=10)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=9)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=8)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=7)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=6)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=5)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=4)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=3)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=2)
.db 0,0,0,0,0,0,0,0,0
#endif
#if (NUM_SLOTS>=1)
.db 0,0,0,0,0,0,0,0,0
#endif
APPEND_CODE_END:
.end
        
