;
;                       PROGRAM VIEW FOR USGARD
;                               by Andreas Ess
;
;shows program data at HL(like Reader from Pascal Bouron)
;
#include "usgard.h"
#include "winlib.h"

.org 0

.db 3

.dw SHOWPROG
.dw SHOWTEXT

SHOWPROG:
	dec    hl
	ld     d, (hl)
	dec    hl
	ld     e, (hl)
	push   de
	inc    hl
	inc    hl
	inc    hl
;Replace $D6(line feed) by $FF
	push   hl
LoopProg:
	ld     a, (hl)
	cp     $D6
	jr     nz, LoopProg_1
	ld     (hl), $FF
LoopProg_1:
	inc    hl
	dec    de
	ld     a, d
	or     e
	jr     nz, LoopProg
	dec    hl
	ld     (hl), 0
	pop    hl
	push   hl
R_ST:	call   SHOWTEXT
	pop    hl
	pop    de
Loop1Prog:
	ld     a, (hl)
	cp     $FF
	jr     nz, Loop1Prog_1
	ld     (hl), $D6
Loop1Prog_1:
	inc    hl
	dec    de
	ld     a, d
	or     e
	jr     nz, Loop1Prog
	dec    hl
	ld     (hl), $D6
	ret

SHOWTEXT:
	push   hl
	push   hl
	ld     hl, USG_BITS
	res    4, (hl)
	LIB_CALL_(1,0)
	ld     hl, USG_BITS
	set    4, (hl)
	pop    hl
	pop    ix
	ld     b, 0
FindLines:
	ld     a, (hl)
	inc    hl
	and    a
	jr     z, FindDone
	inc    a
	jr     nz, FindLines
	inc    b
	jr     FindLines
FindDone:
	ld     a, b
R_Max:  ld     (MaxLines), a

	ld     bc, 0
	ld     hl, $1038
R_T:	ld     de, Title
	ld     a, 11b
	LIB_CALL_(WINLIB,WIN_PREPARE)
ShowScroll:
	LIB_CALL_(WINLIB,WIN_SHOW)
Scroll:
	call   	GET_KEY
	and    	a
	jr     	z, Scroll
	cp     	K_UP
	jr     	z, ScrollUp
	cp     	K_DOWN
	jr    	z, ScrollDown
	cp     	K_LEFT
	jr     	z, ScrollUpF
	cp     	K_RIGHT
	jr     	z, ScrollDownF
	cp     	K_EXIT
	ret    	z
	cp	K_MORE
	jr	z, NextParagraph
	cp     	K_ALPHA
	LIB_CALL_(1,1)
	jr     	Scroll
ScrollUp:
	ld     	a, (WIN_SCRLY)
	and    	a
	jr     	z, Scroll
	dec    	a
	ld     	(WIN_SCRLY), a
	jr     	ShowScroll
ScrollDown:
	ld     	a, (WIN_SCRLY)
R_ML:	ld	hl, MaxLines
	cp     	(hl)
	jr    	z, Scroll
	ld     	hl, WIN_SCRLY
	inc    	(hl)
	jr     	ShowScroll
ScrollUpF:
	xor    	a
	ld     	(WIN_SCRLY), a
	jr     	ShowScroll
ScrollDownF:
R_ML0:	ld	a, (MaxLines)
	ld     	(WIN_SCRLY), a
	jr     	ShowScroll
NextParagraph:
	ld	ix, (WIN_CONT)
	ld	hl, WIN_SCRLY
SearchPara:
	ld	a, (ix)
	inc	ix
	and	a
	jr	z, ShowScroll
	cp	LF
	jr	nz, CheckPara
	inc	(hl)
CheckPara:
	cp	'@'
	jr	nz, SearchPara
	jr	ShowScroll

MaxLines:
 .db 0

Title:
 .db "Text View v1.0",0

.end
