#include "usgard.h"
#include "winlib.h"
#include "usgdlib.h"

.org 0
.db "UsgShell",0
.db WINLIB,0

Progs = TEXT_MEM

Start:
Autostart:
	ld	hl, &Setting
	call    VAR_GET
	jr      c, NoAutostart
	ld      a, 240
	ld      d, 2
	ld      bc, 10000
SearchStartUp:
	cpir
	dec     d
	jr      nz, SearchStartUp
	ld      a, (hl)
	and     a
	jr      z, NoAutostart
	inc     hl
	ld      b, a
ExecuteEm:
	push    bc
	push    hl
	RCALL_(ExecVar)
	pop     hl
	xor     a
	ld      bc, 9
	cpir
	pop     bc
	djnz    ExecuteEm
NoAutostart:

	ld      hl, USG_BITS
	set     4, (hl)         ;Don't mind if not finding library

InitDesktop:
	call	&DrawDesktop

	ld      (iy+8), $8C

WaitF1:
	halt
	call    GET_KEY
	cp      K_EXIT
	ret     z
	cp      K_F1
	jr      nz, WaitF1

	ld      (iy+8), $84
	call    $115

Startwindow_0:
Startwindow:
	call	&DrawDesktop
	ld      bc, $0017
	ld      hl, $0521
	ld      ix, &StartWin
	ld      d, 4
	call    &DrawWindow
	jr      c, InitDesktop

	cp	3
	jr	c, ProgramWindow
;	jp	z, &StartExplore
;	cp	4
	jr      z, StartControl

RunProgram:
	ld      hl, $0005
	ld      ($800C), hl
	ld      bc, $001E
	ld      hl, $071A
	ld      de, &ExecStr
	ld      a, %1
	LIB_CALL_(WINLIB,WIN_PSHOW)
	ld      ix, TEXT_MEM2
	ld      c, 8
	ld	a, 00110000b
	LIB_CALL_(USGDLIB,INPST)
	ld     hl, TEXT_MEM2
ExecAndDeskJP:
	jp      &ExecAndDesk

StartControl:
	ld      hl, &Control
	jr      ExecAndDeskJP

ProgramWindow:
	ld    	hl, &Setting             ;get setting string
	ld      b, a
	call    VAR_GET
	jp      c, &Startwindow_0
	ld      a, (hl)                 ;Check header byte($FF)
	inc     a
	jp      nz, &Startwindow_0

	ld      de, 10                  ;skip background picture
	add     hl, de
	ld      a, b
	and     a
	jr      z, NoFindSection        ;is the section = 0 -> No need to search

	ld      d, a                    ;Find section to show
	ld      a, 240
	ld      bc, 10000
FindSection:
	cpir
	dec     d
	jr      nz, FindSection

NoFindSection:                  ;save all availble programs in GRAPH_MEM
	ld      d, (hl)
	ld      a, d
	and     a
	jp      z, &Startwindow_0	;no programs?!?
	inc     hl
	push    hl

	xor	a
	ld	(Progs), a
	ld      b, d
	ld      de, GRAPH_MEM
;Get program description...
GetDescriptionLoop:
	push    bc
	push    hl
	push    de
	call    VAR_GET
	pop     de
	jr      c, Failed
	inc     hl
	inc     hl
	ld      c, (hl)
	dec	c
	ld      b, 0
	inc     hl
	ldir
	ld      a, LF
	ld      (de), a
	inc     de
	ld	hl, Progs
	inc	(hl)
Failed:
	pop     hl
	xor     a
	ld      bc, 10
	cpir
	pop     bc
	djnz    GetDescriptionLoop
	ld      (de), a

	ld	a, (Progs)
	and	a
	jp	z, &Startwindow

	ld	d, a
	ld      ix, GRAPH_MEM
	dec     d
	ld      bc, $0517
	ld      hl, $0A1B
	call    &DrawWindow
	pop     hl
	jp      c, &Startwindow        ;exit pressed?

;Search program to execute:
	and     a
	jr      z, NoSearchProg
	ld      d, a
	xor     a
	ld      bc, 10000
SearchProg:
	cpir
	dec     d
	jr      nz, SearchProg
NoSearchProg:
	jr      ExecAndDesk

StartExplore:
	ld      hl, &Explorer
ExecAndDesk:
	RCALL_(ExecVar)
	jp 	&Startwindow

DrawWindow:
	push    de
	ld      a, 10b
	LIB_CALL_(WINLIB,WIN_PSHOW)
	pop     bc
	ld	hl, &WinFunc
	LIB_CALL_(WINLIB,WIN_CHC_EX)
	ret

WinFunc:
WinFunc_Loop:
	halt
	call	GET_KEY
	and	A
	jr	z, WinFunc_Loop
	cp	K_ALPHA
	jr	z, ShutDown
	cp	K_LEFT
	jr	z, SameAsExit
	cp	K_RIGHT
	ret	nz
SameAsEnter:
	ld	A, K_ENTER
	ret
SameAsExit:
	ld	A, K_EXIT
	ret
ShutDown:
	call	OTH_SHUTDOWN
	xor	A
	ret

ExecVar:
	call    VAR_EXEC
	ret	c
	ld      a, (USG_BITS)
	bit     1, a
	ret     z
	call  	OTH_EXIT

DrawDesktop:
	call    CLEARLCD

R_Set:  ld      hl, Setting
	call    VAR_GET
	jr      c, NoBkPic1
	inc     hl
	push    hl
	call    VAR_GET
	jr      c, NoBkPic
	inc     hl              ;skip header($00,$7D)
	inc     hl
	ld      de, VIDEO_MEM
	ld      bc, 896
	ldir
NoBkPic:
	pop     hl
NoBkPic1:

	ld      hl, VIDEO_MEM+896
	ld      b, 16
DrawLine:
	ld      (hl), 255
	inc     hl
	djnz    DrawLine
	ld      hl, VIDEO_MEM+912
	ld      b, 7
	ld      de, 13
DrawVLine:
	ld      (hl), 128
	inc     hl
	inc     hl
	ld      (hl), 8
	add     hl, de
	ld      (hl), 1
	inc     hl
	djnz    DrawVLine
	ld      hl, $3902
	ld      ($8333), hl
R_Str:  ld      hl, StartStr
	call    D_ZM_STR
	ret

StartStr:
	.db "Start",0


StartWin:       ;this window pops up on selecting Start(F1)
 .db "Tools",TAB,5,LF
 .db "Games",TAB,5,LF
 .db "Startup",TAB,5,LF
 .db "Control",LF
 .db "Run",0

Control:
 .db "usgdctrl",0

Explorer:
 .db "explore",0

Setting:
 .db "usgdset",0

ExecStr:
 .db "Execute what?",0

.end
